zoukankan      html  css  js  c++  java
  • Codeforces Beta Round #4 (Div. 2 Only) D. Mysterious Present 记忆化搜索

    D. Mysterious Present

    题目连接:

    http://www.codeforces.com/contest/4/problem/D

    Description

    Peter decided to wish happy birthday to his friend from Australia and send him a card. To make his present more mysterious, he decided to make a chain. Chain here is such a sequence of envelopes A = {a1,  a2,  ...,  an}, where the width and the height of the i-th envelope is strictly higher than the width and the height of the (i  -  1)-th envelope respectively. Chain size is the number of envelopes in the chain.

    Peter wants to make the chain of the maximum size from the envelopes he has, the chain should be such, that he'll be able to put a card into it. The card fits into the chain if its width and height is lower than the width and the height of the smallest envelope in the chain respectively. It's forbidden to turn the card and the envelopes.

    Peter has very many envelopes and very little time, this hard task is entrusted to you.

    Input

    The first line contains integers n, w, h (1  ≤ n ≤ 5000, 1 ≤ w,  h  ≤ 106) — amount of envelopes Peter has, the card width and height respectively. Then there follow n lines, each of them contains two integer numbers wi and hi — width and height of the i-th envelope (1 ≤ wi,  hi ≤ 106).

    Output

    In the first line print the maximum chain size. In the second line print the numbers of the envelopes (separated by space), forming the required chain, starting with the number of the smallest envelope. Remember, please, that the card should fit into the smallest envelope. If the chain of maximum size is not unique, print any of the answers.

    If the card does not fit into any of the envelopes, print number 0 in the single line.

    Sample Input

    2 1 1
    2 2
    2 2

    Sample Output

    1
    1

    Hint

    题意

    你有一张长宽为x,y的卡片

    你有n个盒子,长宽分别为xi,yi。

    然后问你卡片最多塞多少层盒子。

    并且把这些盒子按照从里到外输出。

    题解:

    很显然就是一个dp嘛

    由于数据范围只有5000

    那就直接n^2暴力去做就好了……

    数据范围100000其实也可以做的,写个线段树就好了。

    代码

    #include<bits/stdc++.h>
    using namespace std;
    const int maxn = 5005;
    int x[maxn],y[maxn],dp[maxn];
    int from[maxn],n;
    int dfs(int a)
    {
        if(dp[a])return dp[a];
        for(int i=1;i<=n;i++)
        {
            if(x[a]<x[i]&&y[a]<y[i])
                if(dfs(i)+1>dp[a])
                {
                    from[a]=i;
                    dp[a]=dfs(i)+1;
                }
        }
        return dp[a];
    }
    int main()
    {
        scanf("%d",&n);
        for(int i=0;i<=n;i++)
            scanf("%d%d",&x[i],&y[i]);
        int ans = dfs(0);
        printf("%d
    ",ans);
        for(int i=from[0];i;i=from[i])
            printf("%d ",i);
        return 0;
    }
  • 相关阅读:
    Spring IOC(二)beanName 别名管理
    Spring IOC(六)依赖查找
    Spring IOC(五)依赖注入
    Spring IOC(七)类型推断
    Spring 循环引用(二)源码分析
    Spring 循环引用(一)一个循环依赖引发的 BUG
    Spring IOC(四)FactoryBean
    Spring 中的类加载机制
    Spring IOC(三)单例 bean 的注册管理
    Spring Environment(三)生命周期
  • 原文地址:https://www.cnblogs.com/qscqesze/p/5293384.html
Copyright © 2011-2022 走看看